Subject: Re: Publishing "filtered branch repositories" - workflow / recommendations?

From: Jens Lehmann <[email-masked]>
Date: Thu, 05 Dec 2013 20:18:49 +0100

Am 05.12.2013 00:01, schrieb Martin Langhoff:
> Hi folks.
> 
> currently working on a project based on Moodle (the LMS that got me
> into git in the first place). This is a highly modular software, and I
> would like to maintain a bunch of "out of tree" modules in a single
> repository, and be able to publish them in "per-module" repositories.
> 
> So I would like to maintain a tree with looking like
> 
>   auth/foomatic/{code}
>   mod/foomatic/{code}
> 
> where I can develop, branch and tag all the foomatic code together.
> Yet, at release time I want to _also_ publish two repos
> 
>   auth-foomatic.git
>   mod-foomatic.git
> 
> each of them with matching tags and code at the "root" of the git
> tree, and ideally with a truthful history (i.e.: similar to having run
> git filter-branch --subdirectory-filter, but able to update that
> filtered history incrementally).
> 
> Is there a reasonable approach to scripting this?
> 
> Alternatively, has git submodule been improved so that it's usable by
> mere mortals (i.e.: my team), or are there strong alternatives to git
> submodule?

Without knowing more I can't think of a reason why submodules should
not suit your use case (but you'd have to script branching and tagging
yourself until these commands learn to recurse into submodules too).

But maybe you'll be happier with git subtree, dunno.